#!/usr/bin/perl -w -T
#
#	web2yaps.cgi
#
#################################################################
#
# This script is freeware, feel free to share it and modify the
# source code. The use and modification of this code is free of
# charge, as long as this header remains intact.
#
# !!! NO WARRANTY !!!
# !!! NO COMMERCIAL USE !!!
#
# Copyright: GPL
# 
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation - Version 2 of the License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 
#    or look at the internet: www.gnu.org/licenses/licenses.html#GPL
#
#################################################################
#
#  Script basiert auf 'sendsms.cgi' von 
#  www.steines.de/linux/smsscript.html
#  unter der GPL veroeffentlicht
#
#################################################################
#
#  Perl-Script um von einer Web-Site aus, mit Hilfe von YAPS,
#  SMS-Nachrichten	zu verschicken
#
#  Ich habe hier mal zum Testen den "Tainted-Modus" von Perl
#  benutzt. Dieser wird mit dem flag "-T" eingestellt.
#  Dadurch mssen alle evtl. mglichen "verseuchten" Variablen,
#  Daten und Umgebungs-Variablen erst ber eine Kopieraktion
#  mit Hilfe eines regulren Ausdruckes "entseucht" werden.
#  Dabei muss man die erlaubten Zeichen angeben und hat
#  so doch einiges an Sicherheit gewonnen.
#
#################################################################
#
#  Bin noch Perl-Beginner, deshalb etwas Nachsicht. Fr Tips
#  und Feedback bin ich sehr dankbar.
#
#  Autor   :	Heiko Teichmeier
#  Datum   :	04.12.2005
#  Contact :	heiko.teichmeier@tei-lin-net.de
#  Homepage:	www.tei-lin-net.de
#
#################################################################
#  changelog:
#  ----------
#  04.12.2005
#  Lizenz- und Autorenhinweis eingefuegt
#  ----------
#################################################################

use CGI qw/:standard :html3/;

my $in = new CGI;

#########################################################
#   Variablen festlegen         						#
#########################################################
#														#
my ($program_url) = $in->script_name ();				# Variable des Scriptnamens
my $aktual_foot = "04.12.2005 <a href=www.tei-lin-net.de>www.tei-lin-net.de</a>";
# Fusszeile mit letzter Aktualisierung und Mail-Adresse #
#														#
my $maxtry = 3;											# max. Anzahl Whlversuche festlegen
my $yaps = "/usr/bin/yaps";								# Pfad zum Pagerprogramm
my $bg = 'background="/picture/swm_logo_hintergr.jpg"';	# Hintergrund fr Homepage
#my $bg = '';											# Hintergrund fr Homepage
my $css = "/css/swm_1.css";								# CSS-Datei
#														#
### Ende Variablendefinition ############################

my ($level,$versand_messg,$counttry,$title,$sms_nr,$nachricht,$dat,$name);
my ($taint_sms_send,$taint_sms_nr,$taint_nachricht,$taint_name,$taint_title);
if (defined ($in->param('sms_send'))) { (&do_sms_send($in)) }
    else { (&do_sms_eing($in)) }
&print_ende($in);

### untainten fr E-Mail-Adressen (Beispiel) ###
# if ($email =~ /(\w{1}[\w-.]*)\@([\w-.]+)/) {
#    $email = "$1\@$2";
#	}

### Unterprogramme und -prozeduren #####################################

###########################
sub do_sms_eing {
$title = 'SMS - Nachrichten - Formular';

print "Content-type: text/html\n\n";

print <<END_HTML;
<HTML>
   <HEAD>
      <TITLE>"$title"</TITLE>
      <script language="JavaScript"> 
	  <!-- 
	  var nav=navigator.appName.indexOf("Netscape"); var vers=parseInt(navigator.appVersion); 
	  function CheckCount() {
	  var smscount=document.SMSForm.nachricht.value;
	  document.SMSForm.smstextcount.value = smscount.length + 1;
	   if(smscount.length + 1 > 480) { alert("Text darf nicht mehr als 150 Zeichen haben !!!") };
	  }
	  // -->
	  </script>
      <link rel="stylesheet" type="text/css" href="$css">
   </HEAD>
   <BODY $bg>

      <center>
      <TABLE BORDER="0" CELLPADDING="15" WIDTH="480">
         <TR>
            <td class="lgray" width="100%"><h1 class="dblue"><a name="top">$title</h1></a>\n
            <b class="dblue">Hiermit k&ouml;nnt Ihr schnell mal eine SMS-, Scall-,
            Quix- oder Pager-Nachricht versenden.
            <p>Getestet sind z.Zt. folgende Vorwahlen: 0160, 0170, 0171, 0172, 0173, 0174, 0175, 0177, 0178<br>
            Neu Hinzugefgt: 0151 (D1,t-mobile); 0152, 0162 (D2,vodafone); 0163 (E-Plus); 0159, 0176, 0179 (Viag,O2)<br>
            Bitte berichtet mir ber erfolgreich angewhlte andere Vorwahlen (Netzbetreiber haben
            teilweise unterschiedliche Protkolle). Wendet euch auch mit problematischen Rufnummern
            an mich, damit ich diese testen und evtl. Einstellungen ndern kann.</p>
            <p>SMS-Nachrichten d&uuml;rfen max. 160 Zeichen lang sein (Quix, Scall und Pager wei ich nicht).
            Sollten sie l&auml;nger sein, splittet sie dieses Programm in mehrere Nachrichten.<br>
            Aus Grnden der Benutzbarkeit ist hier die max. Eingabemenge auf
            480 Zeichen beschrnkt. Also fasst euch kurz.</b></p>
            <form name="SMSForm" action="$program_url" method=get>

              <TABLE BORDER=0 CELLPADDING="5" cellspacing="5" WIDTH="100%">
                 <TR>
                    <th HEIGHT="25" width="150" ALIGN="left">SMS / Pager - Nr.:</th>\n
                    <TD ALIGN="left" class="yellowbleft" WIDTH="270">\n
			<select name="name" size="1">\n
				<option value="eingabe" selected> Eigene Eingabe (s.u.)\n 
				<option value="Heiko"> Heiko\n 
				<option value="Katrin"> Katrin\n 
				<option value="Denise"> Denise\n
			</select><br>
                    <input type="textfield" name="sms_nr" value="" size="20" maxlength="20"></TD>\n
                 </TR>
                 <TR>
                    <th HEIGHT="120" ALIGN="left">Ihre Nachricht:</th>\n
                    <TD class="yellowbleft">\n
                    <textarea name="nachricht" value="Hier Nachricht eingeben" rows="3" cols="30" maxlength="480" wrap="virtual" onKeypress="CheckCount()"></textarea><br>\n
                    <input type=text name="smstextcount" size=4>&nbsp;&nbsp; Zeichen</TD>\n
                 </TR>
                 <TR>
                    <TD HEIGHT="30">&nbsp;</TD>\n
                    <TD ALIGN="left">
                    <input type="hidden" name="sms_send" value="1">
                    <input type="submit" name="submit_knopf" value="Versenden">
                    <input type="reset"><br><br>
                 </TD>\n
                    </TD>\n
                 </TR>
              </table>

            </endform>
            </td>\n
         </TR>
      </table>

END_HTML
}

##################################
sub do_sms_send{
# Subroutine zum Versenden der eingegebenen SMS-Nachricht
$taint_sms_send = (param('sms_send')) || '';
$taint_sms_send =~ m/([0-9]?)/;
  my $sms_send = $1;
#  my $sms_send = (param('sms_send')) || '';
    if ($sms_send ne "1") {
      $title = "SMS / Pager ==> Versand ==> Fehler";
      print "Content-type: text/html\n\n";

      print <<END_HTML;
      <HTML>
	 <HEAD>
	    <TITLE>"$title"</TITLE>
	    <link rel="stylesheet" type="text/css" href="$css">
	 </HEAD>
	 <BODY $bg>
	 <h1 class="dblue">$title</h1>
	 <h4 class="dblue">Fehler im Programmaufruf! Variable '$sms_send' ist nicht '1'</h4>
	 </body>
      </html>
END_HTML
      }
    else {

		$taint_sms_nr = (param('sms_nr'));
		$taint_sms_nr =~ m/([0-9\/]*)/;
		$sms_nr = $1;
		$taint_nachricht = (param('nachricht'));
		$taint_nachricht =~ m/([\w\,\s\+\-\(\)\?\!\/\:\_\.. ]*)/;
		$nachricht = $1;
		$dat = localtime(time);
		$taint_name = (param('name'));
		$taint_name =~ m/([\w\,\-. ]*)/;
		$name = $1;
			if ($name ne "eingabe") {
			  $sms_nr = $name;
			}

		  ### Header ausgeben
		  print "Content-type: text/html\n\n";

		  print <<END_HTML;
		  <HTML>
		 <HEAD>
END_HTML
		###
		$counttry = 0;
			while($counttry<$maxtry)
				{
					$ENV{PATH} = "";
					my $n = system ("$yaps '$sms_nr' '$nachricht' >/dev/null");
					++$counttry;		# eins weiter zhlen
					###
					if($n ne "0" && $counttry <= $maxtry){
						$versand_messg = "Versand ist nach $counttry Whlversuch(en) fehlgeschlagen :-( !!!<br>\n";
						$title = "SMS / Pager ==> Versand ==> Fehler";
						sleep(5);
						}
					if($n eq "0") {
						$taint_title = (param('page_title'));
						$taint_title =~ m/([\w\,\-. ]*)/;
						$title = $1 || "SMS / Pager ==> Versandmeldung";
						$versand_messg = "wurde  nach $counttry Whlversuch(en) soeben versandt! :-))<br>\n";
						last;
						}
				}
		###
	  print <<END_HTML;
		<TITLE>"$title"</TITLE>
		<link rel="stylesheet" type="text/css" href="$css">
	 </HEAD>
	 <BODY $bg>

		<center>
		<TABLE BORDER="0" CELLPADDING="15" WIDTH="480">
		   <TR>
		  <td class="lgray" width="100%"><h1 class="dblue"><a name="top">$title</h1></a>\n
		<TABLE BORDER=0 CELLPADDING="5" cellspacing="5" WIDTH="100%">
		   <TR>
		  <th HEIGHT="120" WIDTH="100" ALIGN="left">Ihre Nachricht:</th>\n
		  <TD WIDTH="270" class="yellowbleft">$nachricht&nbsp;</TD>\n
		   </TR>
		   <TR>
		  <th HEIGHT="25" ALIGN="left">An Empf&auml;nger:</th>\n
		  <TD ALIGN="left" class="yellowbleft">$sms_nr&nbsp;</TD>\n
		   </TR>
		   <TR>
		  <TD HEIGHT="30">&nbsp;</TD>\n
		  <TD ALIGN="left"><b class="dblue">$versand_messg<br> $dat</b></TD>\n
		   </TR>
		</table>

		  </td>\n
		   </TR>
		</table>
END_HTML
		}
}

########################
sub print_ende {
      print <<END_HTML;
	  <p>
	  <hr noshade="NOSHADE" size="1" width=90%>
	  </center>
	  <p>
	  &copy;&nbsp;$aktual_foot
	  </p>

	 </body>
    </html>
END_HTML
}